﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;
using System.Data.SqlClient;
namespace Aditivos.Models
{
    public class ClsArticulo
    {

        SqlConnection cn = new SqlConnection("Data Source=F80AJS0P1;Initial Catalog=ADITIVOS;Integrated Security=True;User ID=F80AJS0;Password=andres6");
        DataTable DtArticulo = new System.Data.DataTable();
        String cadena;

        public System.Data.DataTable cargar_articulos()
        {
            try
            {
                //SqlCommand consulta = new SqlCommand(string.Format("SELECT idComponente, Nombre, valoraciont, valoracion FROM Componentes"), cn);
                SqlCommand consulta = new SqlCommand("SELECT dbo.Productos.id, dbo.Productos.nombre, dbo.Productos.Marca, SUM(dbo.Componentes.valoracion) AS Suma " +
                            "FROM dbo.Productos INNER JOIN " +
                            "dbo.Producto_Componentes ON dbo.Productos.id = dbo.Producto_Componentes.idProducto INNER JOIN " +
                            "dbo.Componentes ON dbo.Producto_Componentes.idComponente = dbo.Componentes.idComponente " +
                            "GROUP BY dbo.Productos.id, dbo.Productos.nombre, dbo.Productos.Marca", cn);
                SqlDataAdapter da = new SqlDataAdapter(consulta);
                da.Fill(DtArticulo);
                return DtArticulo;
            }
            catch (InvalidCastException e)
            {
                cadena = e.Message;
            }
            return DtArticulo;
        }
        //Con parametros de busqueda
        public System.Data.DataTable cargar_articulos(String sTipoArticulo, String sContiene,String sComponente)
        {
            String sQrycontiene,sQry,sQryArticulo,sQryComponente;

            sQrycontiene = "";

            if (sTipoArticulo == "")
            {
                sQryArticulo = " ";
            }
            else
            {
                sQryArticulo = " Where Productos.Tipo = '" + sTipoArticulo + "'";
            }

            if (sComponente == "")
            {
                sQryComponente = " ";
                sQrycontiene = " ";
            }
            else
            {
                if (sContiene == "1")
                {
                    sQrycontiene = " and exists ";
                }
                else
                {
                    sQrycontiene = " and not exists ";
                }

                sQryComponente = " (select * from Producto_Componentes where Producto_Componentes.idProducto = Productos.id " +
                    " and Producto_Componentes.idComponente = '" + sComponente + "')";
            }
            
            try
            {
                sQry = " SELECT dbo.Productos.id, dbo.Productos.nombre, dbo.Productos.Marca, SUM(dbo.Componentes.valoracion) AS Suma " +
                       "FROM dbo.Productos INNER JOIN " +
                        " dbo.Producto_Componentes ON dbo.Productos.id = dbo.Producto_Componentes.idProducto INNER JOIN" +
                        " dbo.Componentes ON dbo.Producto_Componentes.idComponente = dbo.Componentes.idComponente " + sQryArticulo + sQrycontiene + sQryComponente + 
                        " GROUP BY dbo.Productos.id, dbo.Productos.nombre, dbo.Productos.Marca";
                //SqlCommand consulta = new SqlCommand(string.Format("SELECT idComponente, Nombre, valoraciont, valoracion FROM Componentes"), cn);
                SqlCommand consulta = new SqlCommand(sQry, cn);
                SqlDataAdapter da = new SqlDataAdapter(consulta);
                da.Fill(DtArticulo);
                return DtArticulo;
            }
            catch (InvalidCastException e)
            {
                cadena = e.Message;
            }
            return DtArticulo;
        }

        //Carga el detalle del articulo
        public System.Data.DataTable cargar_articulos_Detalle(String Articulo)
        {
            try
            {
                //SqlCommand consulta = new SqlCommand(string.Format("SELECT idComponente, Nombre, valoraciont, valoracion FROM Componentes"), cn);
                SqlCommand consulta = new SqlCommand("SELECT idProducto, Componentes.idComponente ,Nombre ,Valoracion " +
                    " FROM[Aditivos].[dbo].[Producto_Componentes]  inner join[Aditivos].[dbo].[Componentes] " +
                    " on Componentes.idComponente = Producto_Componentes.idComponente Where idProducto = '" + Articulo + "'", cn);
                SqlDataAdapter da = new SqlDataAdapter(consulta);
                da.Fill(DtArticulo);
                return DtArticulo;
            }
            catch (InvalidCastException e)
            {
                cadena = e.Message;
            }
            return DtArticulo;
        }

        //Recupera los datos de un articulo
        public System.Data.DataTable cargar_articulo(String Articulo)
        {
            try
            {
                String sCadena;
                sCadena = "SELECT[ADITIVOS].[dbo].[Productos].id , [ADITIVOS].[dbo].[Productos].nombre," +
                          " [ADITIVOS].[dbo].[Productos].Marca, [ADITIVOS].[dbo].[Productos].Tipo,[ADITIVOS].[dbo].[Productos].Imagen2, SUM([ADITIVOS].[dbo].[Componentes].valoracion) AS Suma" +
                          " FROM[ADITIVOS].[dbo].[Productos]" +
                          " INNER JOIN[ADITIVOS].[dbo].[Producto_Componentes]" +
                          " ON[ADITIVOS].[dbo].[Productos].id  = [ADITIVOS].[dbo].[Producto_Componentes].idProducto" +
                          " INNER JOIN[ADITIVOS].[dbo].[Componentes]" +
                          " ON[ADITIVOS].[dbo].[Producto_Componentes].idComponente = [ADITIVOS].[dbo].[Componentes].idComponente" +
                          " Where[ADITIVOS].[dbo].[Productos].id = '" + Articulo + "'" +
                          " GROUP BY[ADITIVOS].[dbo].[Productos].id, [ADITIVOS].[dbo].[Productos].nombre, [ADITIVOS].[dbo].[Productos].Marca, [ADITIVOS].[dbo].[Productos].Marca,[ADITIVOS].[dbo].[Productos].Tipo,[ADITIVOS].[dbo].[Productos].Imagen2";
                //SqlCommand consulta = new SqlCommand(string.Format("SELECT idComponente, Nombre, valoraciont, valoracion FROM Componentes"), cn);
                SqlCommand consulta = new SqlCommand(sCadena, cn);
                SqlDataAdapter da = new SqlDataAdapter(consulta);
                da.Fill(DtArticulo);
                return DtArticulo;
            }
            catch (InvalidCastException e)
            {
                cadena = e.Message;
            }
            return DtArticulo;
        }

    }
}